<template>
  <section id="post" class="post" :style="getBackground">
    <div class="container-fluid">
      <div class="small-6 medium-4 columns">
        <a v-bind:href="post.link" class="post">
          <div class="post-details">
            <span>Útimo post no blog:</span>
            <h2 class="post-title">{{ post.title.rendered }}</h2>
            <p class="post-meta"> {{ date }} por {{ user.name }}</p>
          </div>
        </a>
      </div>
      <div class="fade"></div>
    </div>
  </section>
</template>

<script>
  import { getPosts, getFeaturedImage, getAuthor } from '../services/posts'

  export default {
    name: 'post',
    data () {
      return {
        post: {
          id: '',
          title: {
            rendered: ''
          },
          date: 'loading...',
          author: '',
          link: ''
        },
        featured: {
          source_url: ''
        },
        user: {
          name: ''
        }
      }
    },
    methods: {
      fetchPost () {
        return getPosts()
          .then(post => { this.post = post })
          .then(() => getFeaturedImage(this.post.id))
          .then(featured => { this.featured = featured })
          .then(() => getAuthor(this.post.author))
          .then(user => { this.user = user })
      }
    },
    mounted () {
      this.fetchPost()
      setTimeout(() => {
        console.log(this.user.name)
      }, 2000)
    },
    computed: {
      getBackground () {
        return 'background: url(' + this.featured.source_url + ');'
      },
      date () {
        return new Date(this.post.date).toLocaleString('pt-br', {day: 'numeric', month: 'long', year: 'numeric'})
      }
    }
  }
</script>

<!-- Add "scoped" attribute to limit CSS to this component only -->
<style scoped>
</style>
